class Block {
  private int type;
  private int x;
  private int y;
  private float rotation = random(255);
  private boolean active = false;

  public Block(int ix, int iy) {
    x = ix;
    y = iy;
    type = GROUND;
  }

  public Block(int ix, int iy, int itype) {
    x = ix;
    y = iy;
    type = itype;
  }
  
  public Block(int ix, int iy, int itype, float irotation){
    x = ix;
    y = iy;
    type = itype;
    rotation = irotation;
  }

  public void setType(int i) {
    type = i;
  }

  public int getType() {
    return type;
  }

  public int getX() {
    return x;
  }

  public int getY() {
    return y;
  }
  
  public boolean isActive(){
    return active;
  }

  public void drawBlock() {
    //PImage i = createGraphics(blockSize, blockSize);
    if(type == GROUND){
      rectMode(CENTER);
      fill(0);
      noStroke();
      rect(x, y, blockSize, blockSize, blockSize/6);
    }
   if(type == BLACKHOLE){
     translate(x, y);
     rotate(rotation);
     image(blackHoleSprite, 0, 0);
     rotation += 0.004;
     resetMatrix();
   }
   if(type == FIRESTARTER){
     if(active){
       if((frameCount+rotation) % 64  == 0){
         active = false;
       }
       image(activeFireStarterSprite, x, y);
     }else{
       if((frameCount+rotation)% 96 == 0){
         active = true;
       }
       image(fireStarterSprite, x, y);
     }
   }
   if(type == FIRE){
     if(active){
     if((frameCount+rotation) % 64  == 0){
         active = false;
       }
       image(fireSprite, x, y);
     }else{
       if((frameCount+rotation)% 96 == 0){
         active = true;
       }
     }
   }
    //fill(255);
    //ellipse(x, y, 5, 5);
  }
  
}

