ArrayList map = new ArrayList();
public int blockSize = 75;
public final int GROUND = 0;
public final int BLACKHOLE = 1;
public final int FIRESTARTER = 2;
public final int FIRE = 3;

public void loadMap(int level) {
  println("Map Loaded: Level " + level);
  for (int i = map.size()-1; i >= 0; i --) {
    map.remove(i);
    println("Map Reset: Block " + i);
  }
  switch(level) {
  default:
    player.setRotation(random(TWO_PI));
    break;
  case 1:
    map.add(new Block(width/2, height/5*4, BLACKHOLE));
    break;
  case 2:
    for (int i = 0; i < (width/blockSize)+1; i ++) {
      map.add(new Block(i*blockSize, height-blockSize/2));
    }
    for (int i = 0; i < width/blockSize+1; i ++) {
      map.add(new Block(i*blockSize, blockSize/2));
    }
    map.add(new Block(width-blockSize*2, height-blockSize*2, BLACKHOLE));
    player.setX(blockSize*2);
    player.setY(blockSize*2);
    break;
  case 3:
    for (int i = 0; i < width/blockSize+1; i ++) {
      map.add(new Block(i*blockSize, height/3));
    }
    map.add(new Block(width/4*3, height/6*5));
    map.add(new Block(width/4*3+blockSize, height/6*5));
    map.add(new Block(width/4*3-blockSize, height/6*5));
    map.add(new Block(width/4*3, height/6, BLACKHOLE));
    player.setX(width/4*3);
    break;
  case 4:
    for (int x = 0; x < width/blockSize+1; x ++) {
      for (int y = 0; y < height/blockSize+1; y ++) {
        if (x == y) {
          map.add(new Block(x*blockSize, y*blockSize-blockSize/2));
          map.add(new Block(x*blockSize, y*blockSize+blockSize*3));
        }
      }
    }
    map.add(new Block(width-blockSize*2, height-blockSize, BLACKHOLE));
    player.setX(blockSize);
    player.setY(blockSize*2);
    break;
  case 5:
    for (int i = 0; i < height/blockSize; i ++) {
      map.add(new Block(width-blockSize/2, i*blockSize+blockSize/2));
    }
    for (int i = 0; i < width/blockSize; i ++) {
      map.add(new Block(i*blockSize+blockSize/2, blockSize/2));
    }
    for (int i = 0; i < height/blockSize-3; i ++) {
      map.add(new Block(6*blockSize+blockSize/2, i*blockSize+3*blockSize/2));
    }
    map.add(new Block(7*blockSize+blockSize/2, (height/blockSize-3)*blockSize+3*blockSize/2));
    for (int i = 0; i < width/blockSize-6; i ++) {
      map.add(new Block(i*blockSize + blockSize/2, blockSize/2*7));
    }
    for (int i = 0; i < width/blockSize-6; i ++) {
      map.add(new Block(i*blockSize + blockSize/2*5, blockSize*6+blockSize/2));
    }
    map.add(new Block(width-blockSize*2, blockSize*2, BLACKHOLE));
    player.setX(blockSize);
    player.setY(blockSize*2);
    break;
  case 7:
    map.add(new Block(blockSize/2, blockSize/2));
    map.add(new Block(blockSize*2, blockSize/2));
    for(int i = 0; i < height/blockSize-4; i ++){
      map.add(new Block(blockSize*2, i*blockSize+blockSize/2));
    }
    for(int i = 0; i < height/blockSize-1; i ++){
      map.add(new Block(blockSize/2, i*blockSize+blockSize/2));
    }
    for(int i = 0; i < height/blockSize-1; i ++){
      map.add(new Block(width-blockSize-blockSize/2, i*blockSize+3*blockSize/2));
    }
    map.add(new Block(width-blockSize/2, blockSize+blockSize/2));
    map.add(new Block(blockSize+blockSize/2, height-blockSize-blockSize/2));
    map.add(new Block(blockSize*2+blockSize/2, height-blockSize-blockSize/2));
    map.add(new Block(blockSize*3+blockSize/2, height-blockSize-blockSize/2));
    map.add(new Block(blockSize*4+blockSize/2, height-blockSize-blockSize/2));
    map.add(new Block(blockSize*4+blockSize/2, height-blockSize*2-blockSize/2));
    map.add(new Block(blockSize*4+blockSize/2, height-blockSize*3-blockSize/2));
    map.add(new Block(blockSize*4, height-blockSize*4-blockSize/2));
    map.add(new Block(blockSize*3, height-blockSize*4-blockSize/2));
    map.add(new Block(blockSize*3, height-blockSize*3, BLACKHOLE));
    player.setX(width-blockSize/2);
    player.setY(blockSize*2+blockSize/2);
    player.setRotation(4);
    break;
  case 6:
    map.add(new Block(width/2+blockSize*2, height-blockSize, BLACKHOLE));
    map.add(new Block(width/2, blockSize/2));
    map.add(new Block(width/2+blockSize*2, blockSize/2));
    map.add(new Block(width/2+blockSize, blockSize/2));
    for(int i = 0; i < height/blockSize - 2; i ++){
      map.add(new Block(width/2+blockSize, i*blockSize+blockSize/2+blockSize*2));
    }
    for(int i = 0; i < height/blockSize; i ++){
      map.add(new Block(width/2-blockSize, i*blockSize+blockSize/2));
    }
    for(int i = 0; i < height/blockSize; i ++){
      map.add(new Block(width/2+blockSize*3, i*blockSize+blockSize/2));
    }
    player.setX(width/2);
    player.setY(height-blockSize);
    break;
  case 8:
    for(int i = 0; i < width/blockSize - 2; i ++){
      map.add(new Block(i * blockSize+blockSize/2+blockSize*2, blockSize/2));
      map.add(new Block(i * blockSize+blockSize/2, 2*blockSize+blockSize/2));
      map.add(new Block(i * blockSize+blockSize/2+blockSize*2, 4*blockSize+blockSize/2));
      map.add(new Block(i * blockSize+blockSize/2, 6*blockSize+blockSize/2));
      map.add(new Block(i * blockSize+blockSize/2+blockSize*2, 8*blockSize+blockSize/2));
    }
    map.add(new Block(blockSize, blockSize, BLACKHOLE));
    player.setX(width-blockSize/2);
    player.setY(height-blockSize/2);
    break;
  case 9:
    for(int i = 0; i < width/blockSize; i++){
      map.add(new Block(i*blockSize+blockSize/2, blockSize/2));
      map.add(new Block(blockSize/2, i*blockSize+blockSize/2));
      map.add(new Block(blockSize*2, i*blockSize+blockSize/2+blockSize*2));
      if( i < 8){
      map.add(new Block(i*blockSize+blockSize*2, blockSize/2+blockSize*2));
      map.add(new Block(i*blockSize+blockSize*2+blockSize+blockSize/2, blockSize/2+blockSize*4));
      map.add(new Block(i*blockSize+blockSize*2, blockSize/2+blockSize*6));
      map.add(new Block(i*blockSize+blockSize*2+blockSize+blockSize/2, blockSize/2+blockSize*8));
      map.add(new Block(i*blockSize+blockSize*2, blockSize/2+blockSize*2));
      }
    }
    player.setX(blockSize+blockSize/4);
    player.setY(width-blockSize/2);
    map.add(new Block(width-blockSize, height-blockSize/2, BLACKHOLE));
    break;
  case 10:
    map.add(new Block(width/2, height/3*2, BLACKHOLE));
    player.setY(height/3);
  }
  blocks = loadImage("data/Blocks.png");
  blackHoleSprite = loadImage("data/BlackHole.png");
  fireStarterSprite = loadImage("data/FireStarter.png");
  activeFireStarterSprite = loadImage("data/FireStarterActive.png");
  fireSprite = loadImage("data/Fire.png");
  println("Blocks Loaded: " + map.size());
}

public void drawMap() {
  for (int i = 0; i < map.size(); i ++) {
    Block block = (Block) map.get(i);
    block.drawBlock();
    if (player.getX() > block.getX() - blockSize/2-1 && player.getX() < block.getX()+blockSize/2+1) {
      if (player.getY() > block.getY() - blockSize/2-1 && player.getY() < block.getY()+blockSize/2+1) {
        if (block.getType() == GROUND) {
          gameOver();
        }
        if (block.getType() == BLACKHOLE) {
          winLevel();
        }
        if (block.getType() == FIRE || block.getType() == FIRESTARTER && block.isActive()) {
          gameOver();
        }
      }
    }
    if (block.getType() == BLACKHOLE) {
      if (player.getX() > block.getX() - 2*blockSize && player.getX() < block.getX() + 2*blockSize && player.getY() < block.getY() + 2*blockSize && player.getY() > block.getY() - 2*blockSize) {
        if (player.getX() > block.getX() - 2*blockSize) {
          player.setX(player.getX() - 25);
        }
        if (player.getX() < block.getX() + 2*blockSize) {
          player.setX(player.getX() + 25);
        }
        if (player.getY() > block.getY() - 2*blockSize) {
          player.setY(player.getY() - 25);
        }
        if (player.getY() < block.getY() + 2*blockSize) {
          player.setY(player.getY() + 25);
        }
      }
    }
    if (block.getX() < -blockSize/2) {
      map.remove(i);
    }
    if (block.getX() > width + blockSize/2) {
      map.remove(i);
    }
    if (block.getY() < -blockSize/2) {
      map.remove(i);
    }
    if (block.getY() > height + blockSize/2) {
      map.remove(i);
    }
  }
  println("Blocks Updated: " + map.size());
  stroke(255);
  fill(0);
  textAlign(CENTER);
  // Text/Story:
  switch(level) {
  default:
    textSize(164);
    text("Cruithne", width/2, height/3);
    textSize(32);
    text("by Noah Donnelly (@iandioch)", width/2, height/3*2);
    break;
  case 2:
    textSize(48);
    text("It's been a long journey...", width/2, height/3);
    break;
  case 3:
    textSize(42);
    text("My rockets are tired,\nMy wings are creaking...", width/3, height/2);
    break;
  case 4:
    textSize(106);
    text("Phew!", width/5*3+blockSize, height/5);
    break;
  case 5:
    textSize(36);
    text("When things get tough,\nI like to think of my mentor.", width/3, height/7*6);
    break;
  case 6:
    textSize(42);
    text("The great\nand wise\n'Sputnik 1'", blockSize*2-blockSize/2, height/5);
    break;
  case 7:
    text("Now HE was\na noble vessel.", width/2+blockSize/2, height/3);
    break;
  case 8:
  text("I remember his dying words...", width/2, height/2+blockSize/4*3);
    break;
  case 10:
    text("\"Beep... Beep.... Beep.....\"", width/2, height/2);
    break;
  case 9:
    text(" ", 5, 5);
    break;
  }
}

