class Player {
  private float x;
  private float y;
  private float speed;
  private float rotation;
  private final float topSpeed = 25;
  private PImage sprite;
  private PImage acc_sprite;
  private PImage acc_sprite1;
  private PImage acc_sprite2;
  private boolean accelerating = false;
  private int acc = 0;
  boolean isRising;
  private int shipHeight = 100;
  private int shipWidth = 40;
  boolean landed = true;

  public Player(float ix, float iy, float iro, float ispe) {
    x = ix;
    y = iy;
    rotation = iro;
    speed = ispe;
    sprite = loadImage("Player.png");
    acc_sprite = loadImage("Acc.png");
    acc_sprite1 = loadImage("Acc1.png");
    acc_sprite2 = loadImage("Acc2.png");
    shipHeight=18;
    shipWidth=10;
  }

  public float getX() {
    return x;
  }

  public float getY() {
    return y;
  }

  public void setX(float i) {
    x = i;
  }

  public void setY(float i) {
    y = i;
  }

  public float getRotation() {
    return rotation;
  }

  public void setRotation(float i) {
    rotation = i;
  }

  public float getSpeed() {
    return speed;
  }

  public void setSpeed(float i) {
    speed = i;
  }

  public void isAccelerating(boolean b) {
    accelerating = b;
  }

  public boolean isAccelerating() {
    return accelerating;
  }
  
  public void isLanded(boolean b){
    landed = b;
  }
  
  public boolean isLanded(){
    return landed;
  }

  public void updatePlayer() {
    if(landed){
      speed = 14;
      rotation = PI+PI/2;
    }else{
    float newX = x + speed*cos(rotation);
    float newY = y + speed*sin(rotation);
    x = newX;
    y = newY;
    if (accelerating) {
      if (speed < topSpeed) {
        speed += 0.25;
      }
    }
    else {
      if (speed > 0.25) {
        speed -= 0.2;
      }
    }

    if (frameCount % 2 == 0) {
      if (degrees(rotation) < 270 && rotation > PI/2+0.05) {
        println("Tilted Left. Rotation: " + rotation + "r, " + degrees(rotation) + "deg");
        rotation -= radians(270-degrees(rotation))/16;
      }
      else if (degrees(rotation) > 270) {
        println("Tilted Right. Rotation: " + rotation + "r, " + degrees(rotation) + "deg");
        rotation += radians(degrees(rotation)-270)/16;
      }
      if (rotation < PI/2-0.05) {
        rotation += radians(degrees(rotation) + 90)/16;
        if(rotation < PI/4){
          rotation += .05;
        }
      }
    }
    if (rotation > TWO_PI) {
      rotation -= TWO_PI;
    }
    else if (rotation < 0) {
      rotation += TWO_PI;
    }
    //When you go over one side, you reappear on the other:
    y = y > height ? 0 : y;
    y = y < 0 ? height : y;
    x = x > width ? 0 : x;
    x = x < 0 ? width : x;
    //Gravity:
    y += 15;
    }
  }

  public void drawPlayer(float ix, float iy) {
    PImage i = createGraphics(100, 250);
    resetMatrix();
    translate(ix, iy);
    println("X: " + ix + ", Y: " + iy);
    rotate(rotation + PI*3/2);
    imageMode(CENTER);
    if (accelerating) {
      switch(acc) {
      case 0:
        i= acc_sprite1;
        break;
      case 1:
        i= acc_sprite;
        break;
      case 2:
        i= acc_sprite2;
        break;
      default:
        i= acc_sprite;
        break;
      }
      if (frameCount % 4 == 0) {
        if (isRising) {
          acc ++;
        }
        else {
          acc --;
        }
      }
      if (acc > 2) {
        acc = 2;
        isRising = false;
      }
      if(acc < 1){
        acc = 0;
        isRising = true;
      }
    }
    else{
        i.copy(sprite, 0, 0, 100, 250, 0, 0, 100, 250);
      }
    copy(i, 0, 0, 100, 250, -16, -40, 32, 80);
    resetMatrix();
  }
}

